unit frmGoto1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmGoto = class(TForm)
    cboBookmark: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmGoto: TfrmGoto;

implementation

uses Field1;

{$R *.DFM}



procedure TfrmGoto.Button1Click(Sender: TObject);
var
   nFieldID : Integer;
label
     Exit;

begin
     nFieldID := 0;

    // Search for the requested bookmark
    Repeat
        nFieldID := Form1.TXTextControl1.FieldNext(nFieldID, 0);
        If nFieldID > 0 Then begin
            If Form1.TXTextControl1.FieldData[nFieldID] = (cboBookmark.Text) Then begin
               Goto Exit;
            end;
        end;
    until nFieldID = 0;

    Exit:
    // If the bookmark has been found, select it. Text Control will then
    // automatically scroll to make it visible
    If nFieldID <> 0 Then begin
        Form1.TXTextControl1.FieldCurrent := nFieldID;
        Form1.TXTextControl1.SelStart := Form1.TXTextControl1.FieldStart - 1;
        Form1.TXTextControl1.SelLength := Form1.TXTextControl1.FieldEnd - Form1.TXTextControl1.FieldStart + 1;
        end
    Else
        Application.MessageBox('Bookmark not found.','ERROR',MB_OK);

    Close;

end;

procedure TfrmGoto.Button2Click(Sender: TObject);
begin
     Close;
end;

procedure TfrmGoto.FormShow(Sender: TObject);
var
   nfieldID : Integer;

begin
    nFieldID := 0;

    cboBookmark.Clear;

    // Fill the combobox with bookmarks
    Repeat
        nFieldID := Form1.TXTextControl1.FieldNext(nfieldID, 0);
        If nFieldID > 0 Then cboBookmark.Items.Add (Form1.TXTextControl1.FieldData[nFieldID])
    Until nFieldID = 0;

    // Copy first item to the edit control part of the combo box
    cboBookmark.Text := cboBookmark.Items.Strings[0];
end;

end.
