unit frmInsert1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmInsert = class(TForm)
    Edit1: TEdit;
    btnOK: TButton;
    btnCanc: TButton;
    Label1: TLabel;
    procedure btnOKClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure btnCancClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmInsert: TfrmInsert;

implementation

uses Field1;

{$R *.DFM}



procedure TfrmInsert.btnOKClick(Sender: TObject);
var fieldID : Integer;
begin
    { Insert a bookmark. You cannot insert an empty Marked Text Field, so
      we have to make sure that at least one character is selected before
      we create the field. Add a space if there is no text or if the caret
      is at the end of the text.}
    If Form1.TXTextControl1.SelLength = 0 Then begin
        If Form1.TXTextControl1.SelStart = Length(Form1.TXTextControl1.Text) Then begin
            Form1.TXTextControl1.SelText := ' ';
            Form1.TXTextControl1.SelStart := Form1.TXTextControl1.SelStart - 1;
        end;
        Form1.TXTextControl1.SelLength := 1;
    end;

    // Insert a field and store the bookmark name in its FieldData property
    Form1.TXTextControl1.FieldInsert ('');
    fieldID := Form1.TXTextControl1.FieldCurrent;
    Form1.TXTextControl1.FieldEditAttr [fieldID] := $10 + $2 + $1;
    Form1.TXTextControl1.FieldData[Form1.TXTextControl1.FieldCurrent] := Edit1.Text;
    Form1.TXTextControl1.SelLength := 0;
    Close;

end;

procedure TfrmInsert.Edit1Change(Sender: TObject);
begin
     btnOK.Enabled := Length(Edit1.Text) > 0;
end;

procedure TfrmInsert.btnCancClick(Sender: TObject);
begin
     Close;
end;

procedure TfrmInsert.FormShow(Sender: TObject);
begin
     Edit1.Text := Form1.TXTextControl1.SelText
end;

end.
