unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Tx4oleLib_TLB, OleCtrls, Menus, PgrulLib_TLB, OleCtnrs, Module1, TXGlobal,
  StdCtrls, Printers;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    View1: TMenuItem;
    insert1: TMenuItem;
    Format1: TMenuItem;
    Help1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    PageSetup1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    ControlCharacters1: TMenuItem;
    textFrames1: TMenuItem;
    PageMargins1: TMenuItem;
    N8: TMenuItem;
    Zoom1: TMenuItem;
    FullPage1: TMenuItem;
    N301: TMenuItem;
    N01: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N2001: TMenuItem;
    Image1: TMenuItem;
    Text1: TMenuItem;
    AtCaretPosition1: TMenuItem;
    AsFixedObject1: TMenuItem;
    Character1: TMenuItem;
    Paragraph1: TMenuItem;
    Image2: TMenuItem;
    Frame1: TMenuItem;
    N10: TMenuItem;
    TextColor1: TMenuItem;
    TextBackgroundColor1: TMenuItem;
    ParagraphFrames1: TMenuItem;
    AboutTXPublisher1: TMenuItem;
    TXButtonBar1: TTXButtonBar;
    TXRuler1: TTXRuler;
    PgrRuler: TPgRul;
    TXStatusBar1: TTXStatusBar;
    HScroll1: TScrollBar;
    VScroll1: TScrollBar;
    scrPageNo: TScrollBar;
    TXClient: TTXTextControl;
    TXParent1: TTXTextControl;
    TX1: TTXTextControl;
    TXFrameNo1: TTXTextControl;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    Object1: TMenuItem;
    AtCaretPosition2: TMenuItem;
    AsFixedObject2: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N3: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N4: TMenuItem;
    Replace1: TMenuItem;
    Search1: TMenuItem;
    N5: TMenuItem;
    SelectAll1: TMenuItem;
    N6: TMenuItem;
    AddPages1: TMenuItem;
    RemovePages1: TMenuItem;
    N7: TMenuItem;
    DeleteFrame1: TMenuItem;
    TXTrash: TTXTextControl;
    PrintDialog1: TPrintDialog;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    Function toTwip(I : Integer): Integer;
    Function toPix(I : Integer): Integer;
    procedure HScroll1Change(Sender: TObject);
    procedure VScroll1Change(Sender: TObject);
    procedure New1Click(Sender: TObject);
    Function QuerySaveChanges: Integer;
    procedure Save1Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure SaveFile(sFilename : String);
    procedure TXParent1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TXParent1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TXParent1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure CreateFrameNoWindow(Sender : TObject; nIndex :Integer);
    procedure TX1Size(Sender: TObject);
    procedure TX1Change(Sender: TObject);
    procedure TX1Click(Sender: TObject);
    procedure TX1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TX1Move(Sender: TObject);
    procedure TX1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TX1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TXClientMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FullPage1Click(Sender: TObject);
    Procedure ZoomIt;
    procedure N301Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure N751Click(Sender: TObject);
    procedure N01Click(Sender: TObject);
    procedure ControlCharacters1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure copy1Click(Sender: TObject);
    procedure paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Character1Click(Sender: TObject);
    procedure Paragraph1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Frame1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure textFrames1Click(Sender: TObject);
    procedure insert1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);
    procedure AtCaretPosition1Click(Sender: TObject);
    procedure AsFixedObject1Click(Sender: TObject);
    procedure AddPages1Click(Sender: TObject);
    procedure scrPageNoChange(Sender: TObject);
    procedure RemovePages1Click(Sender: TObject);
    procedure DeleteAllControlsOnPage(nPageNo : Integer);
    Procedure DeleteFrame(ctr : TWinControl; bShowMsgBox : Boolean);
    procedure DeleteFrame1Click(Sender: TObject);
    procedure Format1Click(Sender: TObject);
    Procedure FormatColorProc(ctr : TTXTextControl; bTextColor : Boolean);
    procedure TextColor1Click(Sender: TObject);
    procedure TextBackgroundColor1Click(Sender: TObject);
    procedure ParagraphFrames1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure AtCaretPosition2Click(Sender: TObject);
    procedure AsFixedObject2Click(Sender: TObject);
    procedure AboutTXPublisher1Click(Sender: TObject);
    procedure ConnectFrames(Source, Target : TTXTextControl);
    procedure Find(name : String; Index : Integer);
    procedure Find2(name : String; Index : Integer);
    procedure Open1Click(Sender: TObject);
    procedure PageSetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

glX, glY, glXs, glYs : Integer;  // Coordinates for user-drawn rectangle
glDragX, glDragY : Integer;
glbMouseDown : Boolean;         // True while left mouse button is depressed
glbDrag : Boolean;              // True when Dragging was started
glbRulerMouseDown : Boolean;    // True while ruler origin is moved
glbRulerOffsetX : Integer;      // Ruler origin; 0 unless user has changed it
glbRulerOffsetY : Integer;
glbRulerMoveX : Integer;
glbRulerMoveY : Integer;
glbDocDirty : Boolean;          // True if document needs to be saved
glbTrashNo : Integer;           // No. for deleted controls

TXhWnd : TComponent;            // Handle of Text Controls when found by FindComponent
TXhWnd2 : TComponent;           // 2nd handle if more than one is needed
TXNew : TTXTextControl;         // Handle of created Text Controls

Const
MSGBOXCAPTION = 'TX Publisher';
APPTITLE = 'TX Publisher - ';
UNTITLED = 'Untitled';

implementation

uses ImgDlg, frameAttr, framedlg, AboutDlg, PageDlg;

{$R *.DFM}

procedure TfrmMain.FormResize(Sender: TObject);
var
   w, h, pb, lScrX, lScrY : LongInt;
   VScrMax, HScrMax : Integer;
   n : Integer;
begin

    // Quit if window has been minimized
    If frmMain.WindowState = wsMinimized Then Exit;

    w := doc.lWidth * doc.lZoom div 100;
    h := doc.lHeight * doc.lZoom div 100;
    pb := PAGE_BORDER * doc.lZoom div 100;

    lScrX := (HScroll1.position + PAGE_BORDER) * doc.lZoom div 100;
    lScrY := (VScroll1.position + PAGE_BORDER) * doc.lZoom div 100;

    // Move and resize the two currently visible pages
For n := 1 to doc.nPages do begin
    If (n mod 2) = 1 then begin
       Find('TXParent', n);
       TTXTextControl(TXhWnd).Left := toPix(2 * pb - lScrX);
       TTXTextControl(TXhWnd).Top := toPix(2 * pb - lScrY);
       TTXTextControl(TXhWnd).Width := toPix(w);
       TTXTextControl(TXhWnd).Height := toPix(h);
    end
    else begin
         Find('TXParent', n);
         TTXTextControl(TXhWnd).Left := toPix(w + 3 * pb - lScrX);
         TTXTextControl(TXhWnd).Top := toPix(2 * pb - lScrY);
         TTXTextControl(TXhWnd).Width := toPix(w);
         TTXTextControl(TXhWnd).Height := toPix(h);
    end;
end;
    // Adjust client window size and scrollbar positions
    VScroll1.left := ClientWidth - VScroll1.Width;
    HScroll1.top := ClientHeight - HScroll1.Height - TXStatusBar1.Height;
    VScroll1.Height := ClientHeight - TXButtonBar1.Height - TXStatusBar1.Height - VScroll1.Width;
    TXClient.Left := toPix(PAGE_BORDER);
    TXClient.Top := toPix(PAGE_BORDER);
    TXClient.Height := ClientHeight - toPix(PGRULER_WIDTH) - TXButtonBar1.Height - TXStatusBar1.Height - HScroll1.Height;
    TXClient.Width := (ClientWidth - VScroll1.Width - toPix(PGRULER_WIDTH));
    HScroll1.Width := ClientWidth - scrPageNo.Width - VScroll1.Width;
    scrPageNo.top := ClientHeight - scrPageNo.Height - TXStatusBar1.Height;
    scrPageNo.left := ClientWidth - scrPageNo.Width - VScroll1.Width;

    // Adjust scrollbar range. Scrollbar range is page size + borders -
    // client area size at 100% zoom (in twips).
    HScrMax := 2 * doc.lWidth - toTwip(TXClient.Width) * 100 div doc.lZoom + 3 * PAGE_BORDER;
    VScrMax := doc.lHeight - toTwip(TXClient.Height) * 100 div doc.lZoom + 2 * PAGE_BORDER;
    If HScrMax < HScroll1.Min then HScroll1.Max := HScroll1.Min
       else HScroll1.Max := HScrMax;
    If VScrMax < VScroll1.Min then VScroll1.Max := VScroll1.Min
       else VScroll1.Max := VScrMax;

    // Resize page ruler.
    Find('TXParent', doc.nActivePage);
    pgrRuler.OriginX := toTwip(TTXTextControl(TXhWnd).Left);
    pgrRuler.OriginY := toTwip(TTXTextControl(TXhWnd).Top);
    pgrRuler.Width := ClientWidth - VScroll1.Width;
    pgrRuler.Height := ClientHeight - TXButtonBar1.Height - TXStatusBar1.Height - (TXRuler1.Height - 20) - HScroll1.Height;

    // Set scrollbar change values
    VScroll1.SmallChange := PgrRuler.Height div 10;
    HScroll1.SmallChange := PgrRuler.Width div 10;
    VScroll1.LargeChange := PgrRuler.Height * 4 div 5;
    HScroll1.LargeChange := PgrRuler.Width * 4 div 5;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin

    TXStatusBar1.PageMode := 1;

    // Set zoom factor.
    doc.lZoom := 100;

    TX1.PrintOffset := True;

    // Set default measurement for dialog boxes and rulers,
    // and paper size
    If ((TX1.Language = 49) Or (TX1.Language = 41) Or (TX1.Language = 43)) Then begin
        TWIP_PIXEL_FACTOR := (TWIPS_IN_INCH div frmMain.PixelsPerInch);
        glnMeasurement := M_CM;
        pgrRuler.Units := 0;
        doc.nPaperSize := 0;
        doc.lWidth := DINA4_X;
        doc.lHeight := DINA4_Y;
        doc.lLeftMargin := TWIPS_IN_CM;
        doc.lRightMargin := TWIPS_IN_CM;
        doc.lTopMargin := TWIPS_IN_CM;
        doc.lBottomMargin := TWIPS_IN_CM;
        end
    Else begin
        TWIP_PIXEL_FACTOR := (TWIPS_IN_INCH div frmMain.PixelsPerInch);
        glnMeasurement := M_INCH;
        pgrRuler.Units := 1;
        doc.nPaperSize := 3;
        doc.lWidth := USLET_X;
        doc.lHeight := USLET_Y;
        doc.lLeftMargin := 0; //DEFAULT_PAGE_MARGIN
        doc.lRightMargin := 0; //DEFAULT_PAGE_MARGIN
        doc.lTopMargin := 0; //DEFAULT_PAGE_MARGIN
        doc.lBottomMargin := 0; //DEFAULT_PAGE_MARGIN
        doc.nActivePage := 1;
    End;

    // Create two initial document pages.
    doc.nPages := 1;
    doc.nTextControls := 1;
    New1Click(Sender);

    // Set main window size
    frmMain.WindowState := wsMaximized;

    // Set control positions. Values which change when the
    // form is resized are set in the Resize event procdure.
    VScroll1.top := TXButtonBar1.Height;
    HScroll1.left := 0;

    VScroll1.Min := 0;
    VScroll1.Position := 0;
    HScroll1.Min := 0;
    HScroll1.Position := 0;

    PgrRuler.BringtoFront;
end;

Function TfrmMain.toTwip(I : Integer): Integer;
begin
     toTwip := I * TWIP_PIXEL_FACTOR;
end;

Function TfrmMain.toPix(I : Integer): Integer;
begin
     toPix := I div TWIP_PIXEL_FACTOR;
end;

procedure TfrmMain.HScroll1Change(Sender: TObject);
var
       l : LongInt;
begin
    l := -(HScroll1.Position * doc.lZoom div 100);

    Find('TXParent', doc.nActivePage);
    TTXTextControl(TXhWnd).left := toPix(l + PAGE_BORDER * doc.lZoom div 100);

    pgrRuler.OriginX := glbRulerOffsetX * doc.lZoom div 100 + toTwip(TTXTextControl(TXhWnd).left);

    Find('TXParent', doc.nActivePage + 1);
    TTXTextControl(TXhWnd).left := toPix(l + (doc.lWidth + 2 * PAGE_BORDER) * doc.lZoom div 100);
end;

procedure TfrmMain.VScroll1Change(Sender: TObject);
var
    l : LongInt;
begin
    l := -(VScroll1.Position * doc.lZoom div 100);

    Find('TXParent', doc.nActivePage);
    TTXTextControl(TXhWnd).Top := toPix(l + PAGE_BORDER * doc.lZoom div 100);

    pgrRuler.OriginY := glbRulerOffsetY + toTwip(TTXTextControl(TXhWnd).Top);

    Find('TXParent', doc.nActivePage + 1);
    TTXTextControl(TXhWnd).Top := toPix(l + PAGE_BORDER * doc.lZoom div 100);
end;

procedure TfrmMain.New1Click(Sender: TObject);
var
    n : Integer;
begin

    // Save changes?
    If (QuerySaveChanges() = mrCancel) Then Exit;

    Caption := APPTITLE + UNTITLED;
    if (doc.nTextControls > 0) then begin
    For n := 1 to doc.nPages do begin
        DeleteAllControlsOnPage(n);
    end;
    end;

    // Delete all pages
    For n := 1 to doc.nPages do begin
        Find('TXParent', n);
        TTXTextControl(TXhWnd).Parent := TXTrash;
        TTXTextControl(TXhWnd).Name := 'TXTrashedParent' + InttoStr(glbTrashNo);
        glbTrashNo := glbTrashNo + 1;
    end;
    doc.nTextControls := 0;
    doc.nPages := 2;

    // Create two initial document pages
    For n := 1 to doc.nPages do begin
        TXNew := TTXTextControl.Create(frmMain);
        TXNew.Name := 'TXParent' + InttoStr(n);
        TXNew.Parent := TXClient;
        TXNew.Visible := True;
        TXNew.OnMouseDown := TXParent1MouseDown;
        TXNew.OnMouseMove := TXParent1MouseMove;
        TXNew.OnMouseUp := TXParent1MouseUp;
        TXNew.EditMode := 2;
    end;

    doc.nActivePage := 1;
    doc.lZoom := 100;
    FormResize(frmMain);

    scrPageNo.Min := doc.nActivePage;
    scrPageNo.Max := doc.nActivePage;
    glbDocDirty := False;
end;

Function TfrmMain.QuerySaveChanges: Integer;
begin
    If glbdocdirty then begin
       Case MessageDlg('Save changes to document?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
            mrNo: begin
                QuerySaveChanges := mrNo;
                glbDocDirty := False;
                end;
            mrYes: begin
                QuerySaveChanges := mrYes;
                Save1Click(frmMain);
                glbDocDirty := False;
                end
            else begin
                QuerySaveChanges := mrCancel;
                end;
        End;
    End
    else
        QuerySaveChanges := mrNo;
end;

procedure TfrmMain.Save1Click(Sender: TObject);
var
   sFilename : String;
begin
    sFilename := Copy(Caption, Length(APPTITLE) + 1, Length(Caption) - (Length(APPTITLE)));
    If sFilename = UNTITLED Then sFilename := '';
    SaveFile (sFilename);
end;

procedure TfrmMain.SaveFile(sFilename : String);
label
     GoOn;
var
    FileHeader : FILE_HEADER;
    n, m, dummy : Integer; txRect32 : RECT32;
    nParent : Integer;
    nNextWindow : Integer;
    lFilePos : LongInt;
    outFile : File of byte;
begin
try

    // Switch to 100% zoom before saving
    If (doc.lZoom <> 100) Then N1001Click(frmMain);

    If (sFilename = '') Then begin
        SaveDialog1.Title := 'Save File';
        SaveDialog1. DefaultExt := 'txp';
        SaveDialog1.filename := '*.txp';
        SaveDialog1.Filter := 'Publisher Files (*.txp)|*.txp';
        If SaveDialog1.Execute then sFilename := SaveDialog1.filename
        else Exit;
    End;

    AssignFile(outFile, sFilename);
    rewrite(outFile);

    // Write file header. Before this, count the controls which
    // have been deleted and adjust the nTextControls and nOLEControls
    // counters accordingly.
    FileHeader.lVersion := DOC_VERSION;
    FileHeader.DocData := doc;

    BlockWrite(outFile,FileHeader,SizeOf(FileHeader));

    // Save TextControls. Coordinates are stored in twips
    // at 100% zoom.
    For n := 1 To doc.nTextControls do begin
        Find('TX',n);
        // Save the TextControl's page number
        nParent := TTXTextControl(TXhWnd).Tag;
        BlockWrite(outFile,nParent,SizeOf(nParent));

        // Save the TextControl's position and size. Use TX_GETRECT
        // instead of Left, Top, Width and Height Properties because
        // the property values are rounded to screen pixels.
        SendMessage(TTXTextControl(TXhWnd).hwnd, TX_GETRECT, 0, Integer(@txRect32));
        TxRect32.left := toTwip(txRect32.left);
        TxRect32.top := toTwip(txRect32.top);
        TxRect32.right := toTwip(txRect32.right);
        TxRect32.bottom := toTwip(txRect32.bottom);
        BlockWrite(outFile,TxRect32,SizeOf(TxRect32));

        // Save index of next window in window chain
    end;

    //Save connections to other frames
    for n := 1 to doc.nTextControls do begin
        dummy := 0;
        Find('TX',n);
        nNextWindow := TTXTextControl(TXhWnd).NextWindow;
        if (nNextWindow <> 0) then begin
           for m := 1 to doc.nTextControls do begin
               Find2('TX', m);
               if(TTXTextControl(TXhWnd2).handle = nNextWindow) then
                   BlockWrite(outFile,m,SizeOf(m));
           end;
        end
        else
            BlockWrite(outFile,dummy ,SizeOf(dummy));
    end;

    lFilePos := FilePos(outFile);
    CloseFile(outFile);

    // Save the text data and formatting
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        lFilePos := TTXTextControl(TXhWnd).Save(sFilename, lFilePos, 3 ,0);
    end;

    Caption := APPTITLE + sFilename;
    Cursor := 0; //DEFAULT
    glbDocDirty := False;

    Exit;

except
    // Cleanup
    Cursor := 0; //DEFAULT
    CloseFile(outFile);

end;
end;

procedure TfrmMain.N1001Click(Sender: TObject);
begin
     doc.lZoom := 100;
     ZoomIt;
     N1001.Checked := True;
end;

procedure TfrmMain.TXParent1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

    // Left mouse button pressed.
    If (Button = mbLeft) Then begin
        glX := X;
        glY := Y;
        glXs := X;
        glYs := Y;
        glbMouseDown := True;
    End;

    // Right mouse button is used for Zoom in/out. Pass the event on to
    // the parent window.
    If (Button = mbRight) Then begin
        TXClientMouseDown(Sender, Button, Shift, X + TTXTextControl(Sender).left, Y + TTXTextControl(Sender).top);
    End;

end;

procedure TfrmMain.TXParent1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
    If (glbMouseDown) Then begin
       glX := X;
       glY := Y;
    End;
end;

procedure TfrmMain.TXParent1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Const
     MIN_FRAME_SIZE = 250; //Minimum frame size (in twips)
begin
try
    If (glbMouseDown And (glXs <> glX)) Then begin

        // Delete last frame and restore mouse pointer
        glbMouseDown := False;
        frmMain.Cursor := 0;

        If ((Abs(glX - glXs) > toPix(MIN_FRAME_SIZE)) And (Abs(glY - glYs) > toPix(MIN_FRAME_SIZE))) Then begin
           // Create a new text control
           TXNew := TTXTextControl.Create(frmMain);
           TXNew.Parent := TTXTextControl(Sender);
           TXNew.Name := 'TX' + InttoStr(doc.nTextControls + 1);
           TXNew.SizeMode := 3;
           TXNew.OnSize := TX1Size;
           TXNew.OnChange := TX1Change;
           TXNew.OnClick := TX1Click;
           TXNew.OnKeyDown := TX1KeyDown;
           TXNew.OnMove := TX1Move;
           TXNew.OnMouseDown := TX1MouseDown;
           TXNew.OnMouseUp := TX1MouseUp;
           TXNew.ZoomFactor := doc.lZoom;

           // Move text control and frame window to their final position and
           // make them visible. For some reason, TextControl does not fire a
           // Size event in this situation, so we have to directly call the
           // TX_Size event procedure.
           TXNew.Left := glXs;
           TXNew.Top := glYs;
           TXNew.Width := Abs(glX - glXs);
           TXNew.Height := Abs(glY - glYs);
           TXNew.Visible := True;
           doc.nTextControls := doc.nTextControls + 1;
           TXNew.RulerHandle := TXRuler1.hwnd;
           TXNew.ButtonBarHandle := TXButtonBar1.hwnd;
           TXNew.StatusBarHandle := TXStatusBar1.hwnd;
           TXNew.SetFocus;

           // Store page number in Tag property
           TXNew.Tag := StrtoInt(Copy(TTXTextControl(Sender).Name, 9, Length(TTXTextControl(Sender).Name)-8));

           glbDocDirty := True;

           CreateFrameNoWindow (TXNew, (doc.nTextControls));
        End;
    End;

    Exit;

except
    MessageBox(NULL, 'An error has occured.', 'Error', MB_OK);
end;
end;

Procedure TfrmMain.CreateFrameNoWindow(Sender : TObject; nIndex :Integer);
begin
    TXNew := TTXTextControl.Create(frmMain);
    TXNew.Parent := TTXTextControl(Sender);
    TXNew.Name := 'TXFrameNo' + InttoStr(nIndex);
    TXNew.ZoomFactor := TTXTextControl(Sender).ZoomFactor;
    TXNew.Text := InttoStr(nIndex);
    TXNew.Height := toPix(375 * doc.lZoom div 100);
    TXNew.Width := toPix(1000 * doc.lZoom div 100);
    TXNew.Top := toPix(75 * doc.lZoom div 100);
    TXNew.BackColor := clSilver;
    TXNew.EditMode := 2;
    TXNew.BorderStyle := 0;
    TXNew.Left := TTXTextControl(TXhWnd).Width - TXNew.Width;
    If TTXTextControl(Sender).BorderStyle = 1 Then TXNew.Visible := True;
    TX1Size(Sender); // Move frame number window to its position
                     // at the right border of the text frame.
End;


procedure TfrmMain.TX1Size(Sender: TObject);
var nIndex : Integer;
begin
     nIndex := StrtoInt(Copy(TTXTextControl(Sender).Name, 3, Length(TTXTextControl(Sender).Name) - 2));
     Find('TXFrameNo', nIndex);
     TTXTextControl(TXhWnd).left := TTXTextControl(Sender).Width - TTXTextControl(TXhWnd).Width;
     glbDocDirty := True;
end;

procedure TfrmMain.TX1Change(Sender: TObject);
var nIndex : Integer;
begin
    glbDocDirty := True;
    nIndex := StrtoInt(Copy(TTXTextControl(Sender).Name, 3, Length(TTXTextControl(Sender).Name) - 2));
    Find('TX', nIndex);
    TTXTextControl(TXhWNd).Refresh;
end;

procedure TfrmMain.TX1Click(Sender: TObject);
begin
    TTXTextControl(Sender).Refresh;
end;

procedure TfrmMain.TX1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    If Key = 45 Then begin
        TTXTextControl(Sender).InsertionMode := Not TTXTextControl(Sender).InsertionMode;
    end;
end;

procedure TfrmMain.TX1Move(Sender: TObject);
begin
    glbDocDirty := True;
end;

procedure TfrmMain.TX1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   nPage : Integer;
begin
     glbDrag := False;
    // Left mouse button with CTRL key depressed is used
    // for connecting text windows. See TX_MouseUp Event.
    if (Shift = [ssCtrl..ssLeft]) then begin
        TTXTextControl(ActiveControl).SelLength := 0;
        glbDrag := True;
        Screen.Cursor := crDrag;
    End;

    // Right mouse button is used for Zoom in/out. Pass the event on to
    // the parent window.
    If (Button = mbRight) Then begin
        nPage := TTXTextControl(Sender).Tag;
        Find('TXParent', nPage);
        TXParent1MouseDown(TXhWnd, Button, Shift, X + TTXTextControl(Sender).left, Y + TTXTexTControl(Sender).top);
    End;
end;

procedure TfrmMain.TX1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   n : Integer;
   up, down, right, left: Integer ;
   ctr1, ctr2 : String;
begin
   If (glbDrag) then begin
     X := X + TTXTextControl(Sender).left;
     Y := Y + TTXTextControl(Sender).top;
     Screen.Cursor := crDefault;
     for n := 1 to doc.nTextControls do begin
         Find('TX', n);
         up := TTXTextControl(TXhWnd).top;
         down := TTXTextControl(TXhWnd).top + TTXTextControl(TXhWnd).height;
         left := TTXTextControl(TXhWnd).left;
         right := TTXTextControl(TXhWnd).left + TTXTextControl(TXhWnd).width;
         if ((up <= y) And (down >= y)) then begin
            if ((left <= x) And (right >= x)) then begin
               ctr1 := TTXTextControl(Sender).Name;
               ctr2 := TTXTextControl(TXhWNd).Name;
               If ((ctr1 = ctr2)AND(TTXTextControl(Sender).NextWindow <> 0)) then begin
                   If (MessageDlg('Delete connection to other frame?', mtConfirmation, [mbYes, mbNo], 0)) = mrYes then
                      ConnectFrames (TTXTextControl(Sender), TTXTextControl(TXhWnd));
               end
               else if (ctr1 <> ctr2) then begin
               if (TTXTextControl(Sender).NextWindow <> TTXTextControl(TXhWnd).handle) then begin
                   If (MessageDlg('Connect frame ' + copy(ctr1, 3, length(ctr1) - 2) + ' and ' + copy(ctr2, 3, length(ctr2) - 2) + '?', mtConfirmation, [mbYes, mbNo], 0)) = mrYes then
                      ConnectFrames(TTXTextControl(Sender), TTXTextControl(TXhWnd))
                   else
                      Exit;
               end;
               end;
            end;
         end;
     end;
     end;
end;

procedure TfrmMain.TXClientMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    // Right mouse button switches zoom factor
    If (Button = mbRight) Then begin
        If (doc.lZoom = 100) Then
            FullPage1Click(Sender)
        Else begin
            // Set Scroll range to maximum value to avoid overflows; will be
            // adjusted in Resize event.
            HScroll1.Max := 32000;
            VScroll1.Max := 32000;
            // Set scroll positions and zoom so that the area which the user
            // has clicked on will become the center of the client area at 200% zoom.
            HScroll1.Position := nmax(HScroll1.Min, HScroll1.Position + X * 100 div doc.lZoom - TXClient.Width div 2);
            VScroll1.Position := nmax(VScroll1.Min, VScroll1.Position + Y * 100 div doc.lZoom - TXClient.Height div 2);
            N1001Click(Sender);
        End;
    End;
end;

procedure TfrmMain.FullPage1Click(Sender: TObject);
var
   lZoomH : LongInt;
begin
     Find('TXParent', doc.nActivePage);
     lZoomH := (TXClient.Height - 2 * toPix(PAGE_BORDER)) * doc.lZoom div TTXTextControl(TXhWnd).Height;
     doc.lZoom := lZoomH;
     ZoomIt;
     FullPage1.Checked := True;
end;

Procedure TfrmMain.ZoomIt;
var
    n : Integer;
begin
     N301.Checked := False;
     N01.Checked := False;
     N751.Checked := False;
     N1001.Checked := False;
     N2001.Checked := False;
     FullPage1.Checked := False;

    pgrRuler.ZoomFactor := doc.lZoom;

    // Zoom TextControls
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        TTXTextControl(TXhWnd).ZoomFactor := doc.lZoom;
        Find('TXFrameNo', n);
        TTXTextControl(TXhWnd).ZoomFactor := doc.lZoom;
    end;

    // Update Page
    FormResize(frmMain);
end;

procedure TfrmMain.N301Click(Sender: TObject);
begin
     doc.lZoom := 30;
     ZoomIt;
     N301.Checked := True;
end;

procedure TfrmMain.N2001Click(Sender: TObject);
begin
     doc.lZoom := 200;
     ZoomIt;
     N2001.Checked := True;
end;

procedure TfrmMain.N751Click(Sender: TObject);
begin
     doc.lZoom := 75;
     ZoomIt;
     N751.Checked := True;
end;

procedure TfrmMain.N01Click(Sender: TObject);
begin
     doc.lZoom := 50;
     ZoomIt;
     N01.Checked := True;
end;

procedure TfrmMain.ControlCharacters1Click(Sender: TObject);
var
    n : Integer;
begin
    ControlCharacters1.Checked := Not ControlCharacters1.Checked;
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        TTXTextControl(TXhWnd).ControlChars := Not TTXTextControl(TXhWnd).ControlChars;
    end;
end;

procedure TfrmMain.Undo1Click(Sender: TObject);
begin
     TTXTextControl(ActiveControl).Undo;
end;

procedure TfrmMain.Redo1Click(Sender: TObject);
begin
     TTXTextControl(ActiveControl).Redo;
end;

procedure TfrmMain.Cut1Click(Sender: TObject);
begin
    // ActiveControl is a TextControl; otherwise the menu
    // item would have been disabled in mnuEdit_Click().
    TTXTextControl(ActiveControl).Clip (CLIP_CUT);
end;

procedure TfrmMain.copy1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).Clip (CLIP_COPY);
end;

procedure TfrmMain.paste1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).Clip (CLIP_PASTE);
end;

procedure TfrmMain.Delete1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).Clip (CLIP_CLEAR);
end;

procedure TfrmMain.Search1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).FindReplace (1);
end;

procedure TfrmMain.Replace1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).FindReplace (2);
end;

procedure TfrmMain.Selectall1Click(Sender: TObject);
var
   n : Integer;
begin
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        TTXTextControl(TXhWnd).SelStart := 0;
        TTXTextControl(TXhWnd).SelLength := -1;
    end;
end;

procedure TfrmMain.Character1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).FontDialog;
end;

procedure TfrmMain.Paragraph1Click(Sender: TObject);
begin
    TTXTextControl(ActiveControl).ParagraphDialog;
end;

procedure TfrmMain.Image2Click(Sender: TObject);
begin
    ctrParam := TTXTextControl(ActiveControl);
    ImageDlg.ShowModal;
end;

procedure TfrmMain.Frame1Click(Sender: TObject);
var
   n : Integer;
begin
    ctrParam := TTXTextControl(ActiveControl);
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        If TTXTextControl(TXhWnd).Tag <> -1 Then begin
            If TTXTextControl(TXhWnd).BackColor = $C0C0C0 Then begin
                ctrParam := TTXTextControl(TXhWnd);
                Exit;
            End;
        End;
    end;
    FrameAtt.ShowModal;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     CanClose := (QuerySaveChanges <> mrCancel);
end;

procedure TfrmMain.textFrames1Click(Sender: TObject);
var
    n : Integer;
begin
    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        Find2('TXFrameNo', n);
        If TTXTextControl(TXhWnd).BorderStyle = 0 Then begin
            TTXTextControl(TXhWnd).BorderStyle := 1;
            TTXTextControl(TXhWnd2).Visible := True;
            textFrames1.Checked := True;
        end
        Else begin
            TTXTextControl(TXhWnd).BorderStyle := 0;
            TTXTextControl(TXhWnd2).Visible := False;
            textFrames1.Checked := False;
        End;
    end;
end;

procedure TfrmMain.insert1Click(Sender: TObject);
begin
    // Disable TextControl specific menu items if
    // no TextControl is active.
    Text1.Enabled := False;
    Image1.Enabled := False;
    If Copy(ActiveControl.Name,1,2) = 'TX' Then begin
            Text1.Enabled := True;
            Image1.Enabled := True;
    End;

end;

procedure TfrmMain.Text1Click(Sender: TObject);
var
    sFilename : String;
begin
try

    OpenDialog1.Title := 'Insert Text';
    OpenDialog1.Filter := 'Text (*.txt)|*.txt|RTF Format (*.rtf)|*.rtf';
    OpenDialog1.Options:=[ofPathMustExist, ofOverwritePrompt, ofHideReadOnly];
    If OpenDialog1.Execute then sFilename := OpenDialog1.filename;

    frmMain.Cursor:=crHourGlass;   // Hourglass

    If UpperCase(copy (sFilename,length(sFilename)- 2, 3)) = 'RTF' Then begin
        // Import RTF file
        TTXTextControl(ActiveControl).Load (sFilename, 0, RTF_FILE, True);
    end
    Else begin
        TTXTextControl(ActiveControl).Load (sFilename, 0, TXT_FILE, True);
    End;

except
    MessageDlg('Can''t import file: ' + sFileName,mtError,[mbOK],0);
    frmMain.Cursor:=0;   // default
end;

end;

procedure TfrmMain.AtCaretPosition1Click(Sender: TObject);
begin
    InsertImage (True, TTXTextControl(ActiveControl), OpenDialog1, 0, 0);
end;

procedure TfrmMain.AsFixedObject1Click(Sender: TObject);
begin
    InsertImage (False, TTXTextControl(ActiveControl), OpenDialog1, 1000, 1000);
end;

procedure TfrmMain.AddPages1Click(Sender: TObject);
var
   n : Integer;
begin
    doc.nPages := doc.nPages + 2;
    For n := (doc.nPages - 1) to doc.nPages do begin
        TXNew := TTXTextControl.Create(frmMain);
        TXNew.Name := 'TXParent' + InttoStr(n);
        TXNew.Parent := TXClient;
        TXNew.Visible := True;
        TXNew.OnMouseDown := TXParent1MouseDown;
        TXNew.OnMouseMove := TXParent1MouseMove;
        TXNew.OnMouseUp := TXParent1MouseUp;
        TXNew.EditMode := 2;
        TXNew.Refresh;
        TXNew.Height := TXParent1.Height;
        TXNew.Width := TXParent1.Width;
        TXNew.Top := TXParent1.Top;
        If (n mod 2) = 1 then
            TXNew.Left := TXParent1.Left
        else
            TXNew.Left := TXParent1.Left + TXParent1.Width + toPix(PAGE_BORDER);
    end;
    scrPageNo.Min := 1;
    scrPageNo.Max := doc.nPages div 2;
    scrPageNo.Position := scrPageNo.Max;
end;

procedure TfrmMain.scrPageNoChange(Sender: TObject);
var
    n : Integer;
begin
     // Make the selected pages visible
    Find('TXParent', doc.nActivePage);
    TTXTextControl(TXhWnd).Visible := False;
    Find('TXParent', doc.nActivePage + 1);
    TTXTextControl(TXhWnd).Visible := False;

    doc.nActivePage := (scrPageNo.Position * 2) - 1;

    Find('TXParent', doc.nActivePage);
    TTXTextControl(TXhWnd).Visible := True;
    Find('TXParent', doc.nActivePage + 1);
    TTXTextControl(TXhWnd).Visible := True;

    TXStatusBar1.TextPage := 'Pages ' + InttoStr(doc.nActivePage) + '-' + InttoStr(doc.nActivePage + 1) + '     Text Frame';

    For n := 1 To doc.nTextControls do begin
        Find('TX', n);
        Find2('TXFrameNo', n);
        If (TTXTextControl(TXhWnd).Tag <> -1) Then begin
            TTXTextControl(TXhWnd).Visible := True;
            TTXTextControl(TXhWnd2).Visible := True;
        End;
    end;
    FormResize(frmMain);
end;



procedure TfrmMain.RemovePages1Click(Sender: TObject);
begin
       Case MessageDlg('Remove pages ' + InttoStr(doc.nPages - 1) + ' and ' + InttoStr(doc.nPages) + '?', mtConfirmation, [mbYes, mbNo], 0) of
            mrNo: begin
                Exit;
                end;
            mrYes: begin
                    // If the pages which are to be deleted are active, hide them
                    // and activate the previous pages.
                    If (doc.nActivePage = doc.nPages - 1) Then begin
                       Find('TXParent', doc.nPages - 3);
                       TTXTextControl(TXhWnd).Visible := True;
                       Find('TXParent', doc.nPages - 2);
                       TTXTextControl(TXhWnd).Visible := True;
                       doc.nActivePage := doc.nActivePage - 2;
                    End;

                    DeleteAllControlsOnPage (doc.nPages - 1);
                    DeleteAllControlsOnPage (doc.nPages);

                    // Delete the last two pages
                    Find('TXParent', doc.nPages);
                    TTXTextControl(TXhWnd).Parent := TXTrash;
                    TTXTextControl(TXhWnd).Name := 'TXTrashedParent' + InttoStr(glbTrashNo);
                    glbTrashNo := glbTrashNo + 1;
                    Find('TXParent', doc.nPages - 1);
                    TTXTextControl(TXhWnd).Parent := TXTrash;
                    TTXTextControl(TXhWnd).Name := 'TXTrashedParent' + InttoStr(glbTrashNo);
                    glbTrashNo := glbTrashNo + 1;
                    doc.nPages := doc.nPages - 2;
                    scrPageNo.Max := scrPageNo.Max - 1;
                end;
        End;
end;

procedure TfrmMain.DeleteAllControlsOnPage(nPageNo : Integer);
label
     start;
var
   n : Integer;
   done : Boolean;
Begin
    // Delete all controls on a page.
start:
    done := true;
    For n := 1 to doc.nTextControls do begin
        Find('TX', n);
        Find2('TXParent', nPageNo);
        If (TTXTextControl(TXhWnd).Parent = TTXTextControl(TXhWnd2)) then begin
           DeleteFrame(TWinControl(TXhWnd), False);
           done := false;
           Break;
        end;
    end;
    if (not done) then goto start;
end;

Procedure TfrmMain.DeleteFrame(ctr : TWinControl; bShowMsgBox : Boolean);
var
   check : String;
   n : Integer;
begin
    // If bShowMsgBox is True then a message box is shown asking
    // the user if he really wants to delete the frame. The controls
    // are not really deleted moved to the invisible control TXTrash.
    check := ctr.ClassName;
    If (ctr.ClassNameIs('TTXTextControl')) Then begin
        If (bShowMsgBox) then begin
            If MessageDlg('Delete text frame ' + (copy(ctr.name, 3, length(ctr.name) - 2) + '?'), mtConfirmation, [mbYes, mbNo], 0) <> mrYes then begin
                Exit;
            End;
        End;
        check := copy(ctr.Name, 3, length(ctr.Name) -2);
        Find('TXFrameNo', StrtoInt(check));
        TTXTextControl(TXhWnd).Parent := TXTrash;
        TTXTextControl(TXhWnd).Name := 'TXTrashedFrameNo' + InttoStr(glbTrashNo);
        ctr.Parent := TXTrash;
        ctr.Name := 'TXTrashedTX' + InttoStr(glbTrashNo);
        glbTrashNo := glbTrashNo + 1;
        For n := (StrtoInt(check)+1) to doc.nTextControls do begin
            Find('TX', n);
            TTXTextControl(TXhWnd).Name := 'TX' + InttoStr(n-1);
            Find('TXFrameNo', n);
            TTXTextControl(TXhWnd).Name := 'TXFrameNo' + InttoStr(n-1);
            TTXTextControl(TXhWnd).Text := InttoStr(n-1);
        end;
        doc.nTextControls := doc.nTextControls - 1;
    End;
end;


procedure TfrmMain.DeleteFrame1Click(Sender: TObject);
begin
       DeleteFrame(TTXTextControl(ActiveControl), true);
end;

procedure TfrmMain.Format1Click(Sender: TObject);
var
   check : String;
begin

    // Disable TextControl specific menu items if
    // no TextControl is active.
    Character1.Enabled := False;
    Paragraph1.Enabled := False;
    Image2.Enabled := False;
    Frame1.Enabled := False;
    TextColor1.Enabled := False;
    TextBackgroundColor1.Enabled := False;
    ParagraphFrames1.Enabled := False;
    TXhWnd := ActiveControl.Parent;
    check := copy(TControl(TXhWnd).name, 3, 1);
    If ActiveControl.ClassNameIs('TTXTextControl') AND (check = 'P') Then begin
        Character1.Enabled := True;
        Paragraph1.Enabled := True;
        Frame1.Enabled := True;
        If (TTXTextControl(ActiveControl).ObjectCurrent <> 0) Then Image2.Enabled := True;
        TextColor1.Enabled := True;
        TextBackgroundColor1.Enabled := True;
        ParagraphFrames1.Enabled := True;
    End;
end;

Procedure TfrmMain.FormatColorProc(ctr : TTXTextControl; bTextColor : Boolean);
    // Show a dialogbox for text color (bTextColor = 1 ) or
    // text background color (bTextColor = 1). Assumes that there is a
    // common dialog control called ColorDialog1 on the form.
var
    lOldColor : LongInt;
    lNewColor : LongInt;
begin
    lNewColor := 0;
    If bTextColor Then lOldColor := ctr.ForeColor
    Else lOldColor := ctr.TextBkColor;

    If (lOldColor = -1) Or (lOldColor = $40000000) Then frmMain.ColorDialog1.Color := 0  //use black if different colors
    Else frmMain.ColorDialog1.Color := lOldColor;

    If frmMain.ColorDialog1.Execute then begin
        lNewColor := frmMain.ColorDialog1.Color;
    end;
    //set new color
    ctr.Refresh;
    If (lOldColor = -1) Or (lNewColor <> lOldColor) Then begin
        If bTextColor Then
            ctr.ForeColor := lNewColor
        Else
            ctr.TextBkColor := lNewColor;
    End;

End;

procedure TfrmMain.TextColor1Click(Sender: TObject);
begin
     FormatColorProc (TTXTextControl(ActiveControl), True);
end;

procedure TfrmMain.TextBackgroundColor1Click(Sender: TObject);
begin
     FormatColorProc (TTXTextControl(ActiveControl), False);
end;

procedure TfrmMain.ParagraphFrames1Click(Sender: TObject);
begin
     ctrParam := TTXTextControl(ActiveControl);
     FramesDlg.ShowModal;
end;

procedure TfrmMain.Edit1Click(Sender: TObject);
var
   nUndoState, nRedoState : Integer;
   check : String;
begin
    Undo1.Enabled := False;
    Redo1.Enabled := False;
    Cut1.Enabled := False;
    Copy1.Enabled := False;
    Delete1.Enabled := False;
    Paste1.Enabled := False;
    Search1.Enabled := False;
    Replace1.Enabled := False;
    SelectAll1.Enabled := False;
    RemovePages1.Enabled := False;
    DeleteFrame1.Enabled := False;

    TXhWnd := ActiveControl.Parent;
    check := copy(TControl(TXhWnd).name, 3, 1);
    If ActiveControl.ClassNameIs('TTXTextControl') AND (check = 'P') Then begin

       //Prepare Undo/Redo menu items
       nUndoState := TTXTextControl(ActiveControl).CanUndo;
       nRedoState := TTXTextControl(ActiveControl).CanRedo;

       Case nUndoState of
           UNDO_INSERT: Undo1.Caption := 'Undo: Input';
           UNDO_DELETE: Undo1.Caption := 'Undo: Deletion';
           UNDO_FORMAT: Undo1.Caption := 'Undo: Formatting'
           else Undo1.Caption := 'Undo';
       end;

       Case nRedoState of
           REDO_INSERT: Redo1.Caption := 'Redo: Input';
           REDO_DELETE: Redo1.Caption := 'Redo: Deletion';
           REDO_FORMAT: Redo1.Caption := 'Redo: Formatting'
           else Redo1.Caption := 'Redo';
       end;

       Undo1.Enabled := (nUndoState <> 0);
       Redo1.Enabled := (nRedoState <> 0);

       //Enable Text Control specific control items
       If (TTXTextControl(ActiveControl).SelLength <> 0) then Begin
           Cut1.Enabled := True;
           Copy1.Enabled := True;
           Delete1.Enabled := True;
       end;
       Paste1.Enabled := True;
       Search1.Enabled := True;
       Replace1.Enabled := True;
       SelectAll1.Enabled := True;
       DeleteFrame1.Enabled := True;
   end;
   If (doc.nPages > 2) then RemovePages1.Enabled := True;

end;

procedure TfrmMain.AtCaretPosition2Click(Sender: TObject);
begin
     InsertObject(False, TTXTextControl(ActiveControl), 0, 0);
end;

procedure TfrmMain.AsFixedObject2Click(Sender: TObject);
begin
     InsertObject(True, TTXTextControl(ActiveControl), 1000, 1000);
end;

procedure TfrmMain.AboutTXPublisher1Click(Sender: TObject);
begin
     frmAbout.ShowModal;
end;

Procedure TfrmMain.ConnectFrames(Source, Target : TTXTextControl);
var
   help : String;
   help2 : String;
   n : Integer;
begin
try
    If (Source = Target) Then begin
            Target.NextWindow := 0;
            help := copy(Source.Name, 3, length(Source.name) - 2);
            Find('TXFrameNo', StrtoInt(help));
            TTXTextControl(TXhWnd).Text := help;
    end
    Else
        If (Source.NextWindow <> Target.hWnd) Then begin
            // Delete exsisting connection
            For n := 1 To doc.nTextControls do begin
                Find('TX', n);
                If (TTXTextControl(TXhWnd).NextWindow = Target.hwnd) Then begin
                    TTXTextControl(TXhWnd).NextWindow := 0;
                    Find('TXFrameNo', n);
                    TTXTextControl(TXhWNd).Text := InttoStr(n);
                    Break;
                End;
            End;
            If (Target.NextWindow = Source.hwnd) Then begin
                Target.NextWindow := 0;
                help := copy(Target.Name, 3, length(Target.name) - 2);
                Find('TXFrameNo', StrtoInt(help));
                TTXTextControl(TXhWnd).Text := help;
            End;
            // Establish new connection
            Source.NextWindow := 0;
            Source.NextWindow := Target.hwnd;
            help := copy(Source.Name, 3, length(Source.name) - 2);
            help2 := copy(Target.Name, 3, length(Target.name) - 2);
            Find('TXFrameNo', StrtoInt(help));
            TTXTextControl(TXhWnd).Text := help + ' ~ ' + help2;
            Source.SetFocus;
        End;
except
     MessageDlg('Cannot connect frames!',mtConfirmation, [mbOK], 0);
end;
end;

procedure TfrmMain.Find(name : String; Index : Integer);
begin
     TXhWnd := FindComponent(Name + InttoStr(Index));
end;

procedure TfrmMain.Find2(name : String; Index : Integer);
begin
     TXhWnd2 := FindComponent(Name + InttoStr(Index));
end;

procedure TfrmMain.Open1Click(Sender: TObject);
var
    FileHeader : FILE_HEADER;
    txRect32 : RECT32;
    n : Integer;
    nParent : Integer;
    nNextWindow : Integer;
    lFilePos : LongInt;
    sFilename : String;
    inpFile : File of byte;
    addNPages, nTextControls : Integer;
begin
try
    // Save changes?
    If (QuerySaveChanges() = mrCancel) Then Exit;

    // Open a document
    OpenDialog1.Title := 'Save File';
    OpenDialog1. DefaultExt := 'txp';
    OpenDialog1.filename := '*.txp';
    OpenDialog1.Filter := 'Publisher Files (*.txp)|*.txp';
    If OpenDialog1.Execute then sFilename := OpenDialog1.filename
    else Exit;

    // Open the selected file
    AssignFile(inpFile,sFilename);
    reset(inpFile);

    // Clear existing document
    New1Click(Sender);

    // Read file header
    BlockRead(inpFile,FileHeader,sizeOf(FileHeader));
    If (FileHeader.lVersion <> DOC_VERSION) Then
      Exit; //       MessageBox(Jenesaisrien!);

    // Create new pages. Page 1 and 2 have already been created
    // by calling New1Click, so start with page 3 + 4.
    doc := FileHeader.DocData;
    nTextControls := doc.nTextControls;
    doc.nTextControls := 0;

    If doc.nPages > 2 then begin
        addNPages := doc.nPages;
        doc.nPages := 2;
        For n := 2 To (addNPages div 2) do begin
            AddPages1Click(Sender);
        end;
    end;
    scrPageNo.Max := doc.nPages div 2;
    FormResize(Sender);

    // Load TextControls
    For n := 1 To nTextControls do begin
        // Create a new text control
        BlockRead(inpFile,nParent,sizeOf(nParent));
        Find('TXParent', nParent);
        TXNew := TTXTextControl.Create(frmMain);
        TXNew.Parent := TTXTextControl(TXhWnd);
        TXNew.Name := 'TX' + InttoStr(n);
        TXNew.SizeMode := 3;
        TXNew.OnSize := TX1Size;
        TXNew.OnChange := TX1Change;
        TXNew.OnClick := TX1Click;
        TXNew.OnKeyDown := TX1KeyDown;
        TXNew.OnMove := TX1Move;
        TXNew.OnMouseDown := TX1MouseDown;
        TXNew.OnMouseUp := TX1MouseUp;
        TXNew.ZoomFactor := doc.lZoom;

        // Move text control and frame window to their final position and
        // make them visible.
        BlockRead(inpFile,txRect32,sizeOf(txRect32));
        TXNew.Left := toPix(TxRect32.Left);
        TXNew.Top := toPix(TxRect32.Top);
        TXNew.Width := toPix(TxRect32.Right) - TXNew.Left;
        TXNew.Height := toPix(TxRect32.Bottom) - TXNew.Top;

        TXNew.Visible := True;
        TXNew.RulerHandle := TXRuler1.hwnd;
        TXNew.ButtonBarHandle := TXButtonBar1.hwnd;
        TXNew.StatusBarHandle := TXStatusBar1.hwnd;
        TXNew.SetFocus;

        // Store page number in Tag property
        TXNew.Tag := nParent;

        glbDocDirty := False;
        doc.nTextControls := doc.nTextControls + 1;
        CreateFrameNoWindow (TXNew, n);
    end;

    for n := 1 to doc.nTextControls do begin
        BlockRead(inpFile,nNextWindow,sizeOf(nNextWindow));
        If (nNextWindow <> 0) Then begin
            Find('TX', n);
            Find2('TX', nNextWindow);
            ConnectFrames(TTXTextControl(TXhWnd), TTXTextControl(TXhWnd2));
        end;
    end;


    lFilePos := filepos(inpFile);
    CloseFile(inpFile);

    // Load text data and formatting
    For n := 1 To nTextControls do begin
        Find('TX', n);
        lFilePos := TTXTextControl(TXhWnd).Load(sFilename, lFilePos, 3, false);
    end;

    // Show the pages that were active when the document was saved
    If doc.nActivePage <> 1 Then
       scrPageNo.Position := doc.nActivePage div 2;

    frmMain.Caption := APPTITLE + sFilename;

    Exit;

except
    // Cleanup
    CloseFile(inpFile);

    // Error handling
    MessageDlg('Cannot load file: ' + sFilename + '.',mtConfirmation, [mbOK], 0);  
end;
end;

procedure TfrmMain.PageSetup1Click(Sender: TObject);
begin
    frmPageDlg.ShowModal;
    formresize(Sender);
    Find('TXParent', doc.nActivePage);
    TTXTextControl(TXhWnd).Refresh;
    Find('TXParent', doc.nActivePage + 1);
    TTXTextControl(TXhWnd).Refresh;
end;

procedure TfrmMain.Print1Click(Sender: TObject);
var
    nLastPage, StartPage, EndPage, CurPage, Copy, n : Integer;
begin
try
    // Determine the last not-empty page
    nLastPage := doc.nPages;

    // Initialize and call the common print dialog
    PrintDialog1.Copies := 1;
    PrintDialog1.FromPage := 1;
    PrintDialog1.ToPage := nLastPage;
    PrintDialog1.MinPage := 1;
    PrintDialog1.MaxPage := doc.nPages;
    PrintDialog1.Options := [poPrintToFile, poPageNums];
    if (PrintDialog1.Execute) then begin
       If poPageNums in PrintDialog1.Options  Then begin
          StartPage := PrintDialog1.FromPage;
          EndPage := PrintDialog1.ToPage;
       End
       else begin
           StartPage := 1;
           EndPage := doc.nPages;
       end;

     // Print selected pages
     Printer.BeginDoc;
     For Copy := 1 To PrintDialog1.Copies do begin
        For CurPage := StartPage To EndPage do begin
            For n := 1 to doc.nTextControls do begin
                Find('TX', n);
                Find2('TXParent', CurPage);
                If (TTXTextControl(TXhWnd).Parent = TTXTextControl(TXhWnd2)) then begin
                   TTXTextControl(TXhWnd).PrintDevice := Printer.Handle;
                   TTXTextControl(TXhWnd).PageMarginL := toTwip(TTXTextControl(TXhWnd).left * 100 div doc.lZoom);
                   TTXTextControl(TXhWnd).PageMarginT := toTwip(TTXTextControl(TXhWnd).top * 100 div doc.lZoom);
                   TTXTextControl(TXhWnd).PrintPage(CurPage);
                end;
            end;
            Printer.NewPage;
        end;
     end;
     Printer.EndDoc;
   end;
except
   on EPrinter do MessageDlg('An ERROR occured while printing!', mtError, [mbOK], 0);
end;
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
     if(QuerySaveChanges <> mrCancel) then close;
end;

procedure TfrmMain.Saveas1Click(Sender: TObject);
begin
     SaveFile('');
end;

end.


